@make(ais)
@aiInfo(topic=<NUMERIC_@|ERROR for nonstatic universal operands>,
number=[AI-00181/04],
classcode=[BI],
statuscode=[WJ],
mainref=[04.10@\(05)],
date=[86-07-23])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class binding interpretation 84-01-25
!status approved by WG9/AJPO 86-07-22
@end(toplines)
!status approved by Director, AJPO 86-07-22
!status approved by WG9/Ada Board 86-07-22
!status approved by Ada Board 86-07-22
!status WG14/ADA Board approved 84-11-27
!status WG14-approved 84-11-27
!status board-approved 84-11-26
!status committee-approved 84-06-28
!status work-item 84-06-12
!status received 84-01-25
@references[!references @CommentNum[83-00267]83-00267]
@topic{!topic @value(aitopic)}
@end(history)

@subheading[!summary 84-12-10]

When evaluating a nonstatic universal expression, NUMERIC_@|ERROR can be raised
if any operand or the result is a real value that lies outside the range of
safe numbers of the most accurate predefined floating point type (excluding
@univ[universal_@|real]) or an integer value that lies outside the range SYSTEM.MIN_@|INT
.. SYSTEM.MAX_@|INT.

@subheading[!question 84-09-10]

4.10(5) allows NUMERIC_@|ERROR to be raised for nonstatic universal expressions
only if the @i[results] for the expressions exceed certain values@dash()
NUMERIC_@|ERROR cannot be raised if the @i[operands] exceed these values.  Now
consider an expression such as:
@begin(example)
10E100 @key[mod] INTEGER'@|POS(X)
@end(example)
The result of this expression will always be less than INTEGER'@|LAST, so
NUMERIC_@|ERROR cannot be raised, but run-time evaluation appears to be required
if X is nonstatic.  Is it acceptable for NUMERIC_@|ERROR to be raised in such
cases?

@subheading[!recommendation 84-12-10]

For the evaluation of an operation of a nonstatic universal expression, an
implementation is allowed to raise the exception NUMERIC_@|ERROR if any operand
or the result is a real value whose absolute value exceeds the largest safe
number of the most accurate predefined floating point type (excluding
@univ[universal_@|real]), or an integer value greater than SYSTEM.MAX_@|INT or less than
SYSTEM.MIN_@|INT.

@subheading[!discussion 84-09-10]

The problem is not limited to integer types.  It is also possible to construct
nonstatic universal real expressions whose result lies within the range of
safe numbers of the largest non-universal real type but with an operand whose
value lies outside this range.  For example,
@begin(example)
LARGE/(2.0@exp()INTEGER'@|POS(X))
@end(example)
is one such expression, where LARGE can be a named number whose value lies
outside the range of safe numbers and a nonstatic X is chosen so the result
lies within that range.

In general, under the current wording, it will sometimes be necessary to
evaluate (at run-time) expressions involving values that cannot necessarily be
represented exactly using the predefined numeric types.  The Standard does
not allow NUMERIC_@|ERROR to be raised in such cases, although it was not the
intent to require the run-time representation of values that exceed the ranges
of the largest real and integer types.

In order to allow efficient and reasonable run-time implementations for
evaluating nonstatic universal expressions, it was the intent to allow
NUMERIC_@|ERROR to be raised when values involved in nonstatic universal
expressions exceeded the range of values for the largest supported integer or
real type.  Therefore, the wording in 4.10(5) should be understood to mean
that NUMERIC_@|ERROR can be raised when a value of a result @i[or operand] is
outside the range of such types.

